#include "Pkt.h"
#include "zlib.h"
#include "swapbytes.h"

// header is Magic string "zlib"
// followed by unsigned int size
#define PKTCOMPRESSIONPF	"packet_compression.pf"
#define PKT_MAGIC  "zlib" 
#define PKT_MAGIC_LEN 4
#define NHEADER (PKT_MAGIC_LEN+sizeof(unsigned int))
static int Initialized = 0 ; 
static int Ok = 0 ; 

int
set_packet_compression ( int ok ) 
{
    int old_ok ;
    old_ok = Ok ;
    Ok = ok ; 
    Initialized = 1 ; 
    return old_ok ;
}

int
ok2compress()
{
    if ( ! Initialized ) { 
	Pf *pf ;
	Initialized = 1 ;
	if ( pfread (PKTCOMPRESSIONPF, &pf) ) { 
	    elog_complain(0, "*** Can't read %s : no packet compression", PKTCOMPRESSIONPF	) ; 
	} else { 
	    Ok = pfget_boolean(pf, "compress_packets") ; 
	    pffree(pf) ; 
	}
    }
    return Ok ;
}

int
pktcompress( Packet *pkt, unsigned char **data, int *nbytes, int *datasz) 
{
    int retcode = 0 ;
    if ( ok2compress() ) { 
	AllocBuffer in, out ; 
	in.data = *data ; 
	in.ndata = *nbytes ; 
	in.allocated_size = *datasz ; 
	out.data = pkt->cbuf ; 
	out.ndata = pkt->cbuf_nbytes ; 
	out.allocated_size = pkt->cbuf_size ; 
	retcode = btcompress(&in, &out) ;
	if ( retcode == 0 ) { 
	    *data = out.data ; 
	    *nbytes = out.ndata ; 
	    *datasz = out.allocated_size ; 
	    pkt->cbuf = in.data ; 
	    pkt->cbuf_nbytes = in.ndata ; 
	    pkt->cbuf_size = in.allocated_size ; 
	} else if ( pkt->cbuf_size != out.allocated_size ) { 
	    pkt->cbuf = out.data ; 
	    pkt->cbuf_nbytes = out.ndata ; 
	    pkt->cbuf_size = out.allocated_size ; 
	    retcode = 1 ; 
	}
    }
    return retcode ;
}
