//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_H
#define CD11_H

#include <iostream>
#include <sstream>
#include <mutex>
#include <stdexcept>
#include <regex>

#include "ooorb.h"
#include "oobns.h"

#include "swapbytes.h"
#include "versign.h"

enum CD11FrameType : int { Unassigned = -1,
			   ConnRequest = 1, 
		           ConnResponse, 
		           OptionRequest, 
		           OptionResponse, 
		           Data, 
		           AckNack, 
		           Alert, 
		           CommandRequest, 
		           CommandResponse, 
		           CD1Encapsulation = 13 
		     	};

#define CD11_PROTOCOL_MAJOR_VERSION 3
#define CD11_PROTOCOL_MINOR_VERSION 4

#include "cd11_exception.h"
#include "cd11_config.h"
#include "cd11_gapset.h"
#include "cd11_frameheader.h"
#include "cd11_frametrailer.h"
#include "cd11_framepayload.h"
#include "cd11_framepayload_crq.h"
#include "cd11_framepayload_crs.h"
#include "cd11_framepayload_orq.h"
#include "cd11_framepayload_ors.h"
#include "cd11_framepayload_data.h"
#include "cd11_framepayload_alert.h"
#include "cd11_framepayload_acknack.h"
#include "cd11_frame.h"
#include "cd11_socket.h"

#endif

