//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_EXCEPTION_H
#define CD11_EXCEPTION_H

#include <iostream>
#include <stdexcept>

class Cd11Exception : public std::runtime_error
{
	public:
			Cd11Exception( std::string what ) : std::runtime_error( what ) {};
			~Cd11Exception( void ) {};
};

class Cd11EOFException : public Cd11Exception
{
	public:
			Cd11EOFException( std::string what ) : Cd11Exception( what ) {};
			~Cd11EOFException( void ) {};
};

class Cd11TimeoutException : public Cd11Exception
{
	public:
			Cd11TimeoutException( std::string what ) : Cd11Exception( what ) {};
			~Cd11TimeoutException( void ) {};
};

class Cd11SocketErrorException : public Cd11Exception
{
	public:
			Cd11SocketErrorException( std::string what ) : Cd11Exception( what ) {};
			~Cd11SocketErrorException( void ) {};
};

class Cd11AuthSignatureException : public Cd11Exception
{
	public:
			Cd11AuthSignatureException( std::string what ) : Cd11Exception( what ) {};
			~Cd11AuthSignatureException( void ) {};
};

class Cd11ChecksumException : public Cd11Exception
{
	public:
				Cd11ChecksumException( std::string what, uint64_t remainder ) : Cd11Exception( what ), m_remainder( remainder ) {};
				~Cd11ChecksumException( void ) {};

		uint64_t	remainder( void ) { return m_remainder; };
		
	private:
		
		uint64_t	m_remainder;		
};

#endif
