//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_H
#define CD11_FRAME_PAYLOAD_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

enum CD11FrameType : int;

class CD11FramePayload
{
	public:
						CD11FramePayload( CD11Frame* frame );
						CD11FramePayload( CD11Frame* frame, OOBns* oobns );
						CD11FramePayload( CD11Frame* frame, std::istream& is );
		virtual				~CD11FramePayload( void );

		static CD11FramePayload* 	create( CD11Frame* frame, OOBns* oobns );
		static CD11FramePayload* 	create( CD11Frame* frame, std::istream& is );

		virtual void			resetPointers( void ) = 0;

		virtual std::string 		toString( void ) = 0;
		
		virtual void 			print( std::ostream& os ) = 0;

		int  				payloadSize( void );

	protected: 
	
		void				unmarshal( OOBns* oobns );
		void				read( std::istream& is );

		CD11Frame*			m_frame;
		int 				m_payloadSize;
};

#endif
