//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_ACKNACK_H
#define CD11_FRAME_PAYLOAD_ACKNACK_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

class GapSet;

class CD11AckNackPayload : public CD11FramePayload
{
	public: 	
					CD11AckNackPayload( CD11Frame* frame, GapSet* gapSet );
					CD11AckNackPayload( CD11Frame* frame, OOBns* oobns );
					CD11AckNackPayload( CD11Frame* frame, std::istream& is );

		void			resetPointers( void );

		std::string 		toString( void );
		
		void 			print( std::ostream& os );

		std::string		frameSetAcked( void );
		int64_t 		lowestSeqNo( void );
		int64_t 		highestSeqNo( void );
		int 			gapCount( void );
		struct gap 		getGap( int igap );
		GapSet* 		gapSet( void );

		void			frameSetAcked( std::string v );
		void 			lowestSeqNo( int64_t v );
		void 			highestSeqNo( int64_t v );
		void 			gapCount( int v );
		void 			setGap( int igap, struct gap agap );

	protected:
	
		char* 			m_nbo_frameSetAcked;
		int64_t*		m_nbo_lowestSeqNo;
		int64_t*		m_nbo_highestSeqNo;
		int* 			m_nbo_gapCount;
		int64_t*		m_nbo_gapEndpoints;	// [lowestMissing,nextPresent), * gapCount
};

#endif
