//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_ALERT_H
#define CD11_FRAME_PAYLOAD_ALERT_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

class CD11AlertPayload : public CD11FramePayload
{
	public: 	
					CD11AlertPayload( CD11Frame* frame, std::string message );
					CD11AlertPayload( CD11Frame* frame, OOBns* oobns );
					CD11AlertPayload( CD11Frame* frame, std::istream& is );

		void			resetPointers( void );

		std::string 		toString( void );
		
		void 			print( std::ostream& os );

		int 			messageSize( void );
		std::string		message( void );

		void 			messageSize( int v );
		void			message( std::string v );

	protected:
	
		int* 			m_nbo_messageSize;
		char* 			m_nbo_message;
};

#endif
