//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_CRQ_H
#define CD11_FRAME_PAYLOAD_CRQ_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

class CD11ConnRequestPayload : public CD11FramePayload
{
	public: 	
					CD11ConnRequestPayload( CD11Frame* frame, std::string sta, std::string statype, int rqip, unsigned short rqport );
					CD11ConnRequestPayload( CD11Frame* frame, OOBns* oobns );
					CD11ConnRequestPayload( CD11Frame* frame, std::istream& is );

		void			resetPointers( void );

		std::string 		toString( void );
		
		void 			print( std::ostream& os );

		short 			majorVersion( void );
		short 			minorVersion( void );
		std::string		stationName( void );
		std::string 		stationType( void );
		std::string 		serviceType( void );
		std::string		requesterIPDottedDecimal( void );
		int 			requesterIPAddress( void );
		unsigned short		requesterPort( void );
		int			secondIPAddress( void );
		unsigned short		secondPort( void );

		void 			majorVersion( short v );
		void 			minorVersion( short v );
		void			stationName( std::string v );
		void	 		stationType( std::string v );
		void	 		serviceType( std::string v );
		void 			requesterIPAddress( int v );
		void 			requesterPort( unsigned short v );
		void			secondIPAddress( int v );
		void			secondPort( unsigned short v );

	protected:
	
		short* 			m_nbo_majorVersion;
		short* 			m_nbo_minorVersion;
		char* 			m_nbo_stationName;
		char* 			m_nbo_stationType;
		char* 			m_nbo_serviceType;
		int* 			m_nbo_requesterIPAddress;
		short* 			m_nbo_requesterPort;
		int* 			m_nbo_secondIPAddress;
		short* 			m_nbo_secondPort;

};

#endif
