//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_CRS_H
#define CD11_FRAME_PAYLOAD_CRS_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

class CD11ConnResponsePayload : public CD11FramePayload
{
	public: 	
					CD11ConnResponsePayload( CD11Frame* frame, int responderip, unsigned short responderport );
					CD11ConnResponsePayload( CD11Frame* frame, OOBns* oobns );
					CD11ConnResponsePayload( CD11Frame* frame, std::istream& is );

		void			resetPointers( void );

		std::string 		toString( void );
		
		void 			print( std::ostream& os );

		short 			majorVersion( void );
		short 			minorVersion( void );
		std::string		responderName( void );
		std::string 		responderType( void );
		std::string 		serviceType( void );
		std::string 		responderIPDottedDecimal( void );
		int 			responderIPAddress( void );
		unsigned short		responderPort( void );
		int			secondIPAddress( void );
		unsigned short		secondPort( void );

		void 			majorVersion( short v );
		void 			minorVersion( short v );
		void			responderName( std::string v );
		void	 		responderType( std::string v );
		void	 		serviceType( std::string v );
		void 			responderIPAddress( int v );
		void 			responderPort( unsigned short v );
		void			secondIPAddress( int v );
		void			secondPort( unsigned short v );

	protected: 
	
		short* 			m_nbo_majorVersion;
		short* 			m_nbo_minorVersion;
		char* 			m_nbo_responderName;
		char* 			m_nbo_responderType;
		char* 			m_nbo_serviceType;
		int* 			m_nbo_responderIPAddress;
		short* 			m_nbo_responderPort;
		int* 			m_nbo_secondIPAddress;
		short* 			m_nbo_secondPort;	
};

#endif
