//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_DATA_H
#define CD11_FRAME_PAYLOAD_DATA_H

#define CD11_ASCIITIME_LENGTH_BYTES 20
#define CD11_SINGLE_CHANNELSTRING_NBYTES 10

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

class CD11DataPayload : public CD11FramePayload
{
	public: 	
						CD11DataPayload( CD11Frame* frame, std::shared_ptr<OooOrbPacket> op );
						CD11DataPayload( CD11Frame* frame, OOBns* oobns );
						CD11DataPayload( CD11Frame* frame, std::istream& is );

		void				resetPointers( void );

		std::string 			toString( void );
		
		void 				print( std::ostream& os );

		int				nChannels( void );
		double 				nominalTime( void );
		int				channelStringCount( void );
		Tbl*				channelStrings( void );
		std::shared_ptr<OooOrbPacket>	orbPacket( std::string network, std::string stationName );

	protected: 
	
		int 				m_nchannels;
		int*				m_nbo_nChannels;
		int*				m_nbo_msecFrameTimeLength;
		char*				m_nbo_nominalTime;
		int*				m_nbo_channelStringCount;
		char*				m_nbo_channelString;
		unsigned char*			m_nbo_channelSubframes;

	private:

		char* 				channelLine2seedCode( std::string network, char* channelLine );
	};

#endif
