//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_FRAME_PAYLOAD_ORS_H
#define CD11_FRAME_PAYLOAD_ORS_H

#include <iostream>

#include "ooorb.h"
#include "oobns.h"

// Fully general implementation would take an arbitrary number of option requests. 
// Currently structured to handle only one since there's only one known option 
// defined in protocol. This response object just agrees to the incoming request.

class CD11OptionResponsePayload : public CD11FramePayload
{
	public: 	
					CD11OptionResponsePayload( CD11Frame* frame, CD11OptionRequestPayload* orqPayload );
					CD11OptionResponsePayload( CD11Frame* frame, OOBns* oobns );
					CD11OptionResponsePayload( CD11Frame* frame, std::istream& is );

		void			resetPointers( void );

		std::string 		toString( void );
		
		void 			print( std::ostream& os );

		int 			optionCount( void );
		int 			option1Type( void );
		int 			option1Size( void );
		std::string		option1Response( void );

		void 			optionCount( int v );
		void 			option1Type( int v );
		void 			option1Size( int v );
		void	 		option1Response( std::string v );


	protected:
	
		int* 			m_nbo_optionCount;
		int* 			m_nbo_option1Type;
		int* 			m_nbo_option1Size;
		char* 			m_nbo_option1Response;

};

#endif
