//   Copyright (c) 2016 Boulder Real Time Technologies, Inc.           
//                                                                     
//   This software module is wholly owned by Boulder Real Time         
//   Technologies, Inc. Any use of this software module without        
//   express written permission from Boulder Real Time Technologies,   
//   Inc. is prohibited.                                               

#ifndef CD11_GAPSET_H
#define CD11_GAPSET_H

#include "Table.h"

class CD11Frame;

struct gap {
	gap( void ) {
		memset( this, 0, sizeof(gap) );
	}

	int64_t 				m_lowestMissing;
	int64_t 				m_nextPresent;
};

class GapSet 
{
	public:

						GapSet( std::string frameSet );
						GapSet( std::string frameSet, Pf* frameSetPf );
						~GapSet( void );

		void				track( std::shared_ptr<CD11Frame> cd11Frame );
		void				write_state( int fdstate );

		int 				nGaps( void );
		struct gap 			getGap( int index );
		int64_t 			lowestSeqNo( void );
		int64_t 			highestSeqNo( void );
		std::string 			frameSet( void );
		int64_t 			popHighestMissingSeqNo( void );

		void 				lowestSeqNo( int64_t v );
		void 				highestSeqNo( int64_t v );
		void 				pushGap( struct gap agap );

	private: 

		std::string 			m_frameSet;
		int64_t 			m_lowestSequenceNumber;
		int64_t 			m_lastSequenceNumber;
		Table<gap>			m_gaps;
};

#endif